#!/bin/sh

MYDIR=`pwd`
LIBSDIR=../../../libs
DOCSDIR=../../../docs

# Defaults
DEBUG=DEBUG=0
OPTMIZE=OPT=-O
DIRNAME=pgp-6.5.1i
UNIXVERSION=`./unix/config/config.guess`
PACKAGENAME="pgp-6.5.1i-$UNIXVERSION"

# Platform specific hacks
if [ `uname -s` = "Linux" ]; then
  LINUX="LINUX=1"
fi
if [ `uname -s` = "SunOS" ]; then
  DIRNAME=pgpcmdln
fi
if [ `uname -s` = "HP-UX" ]; then
  OPTMIZE=
fi

# Create directories
mkdir $LIBSDIR/network/ldaplib/unix

# Build pfl
cd $LIBSDIR/pfl
./configure
make clean
make CC=gcc $OPTMIZE $DEBUG $LINUX world

# Build PGPsdk
cd ../pgpcdk
./configure
make clean
make CC=gcc $OPTMIZE $DEBUG $LINUX world

# Build PGPsdk UI library
cd ./unix/ui
make clean
make CC=gcc $OPTMIZE $DEBUG $LINUX all

# Build PGP shared code
cd ../../../../clients/pgp/shared
./configure
make clean
make CC=gcc $OPTMIZE $DEBUG $LINUX all

# Build PGPcmdline
cd ../cmdline
./configure
make clean
make CC=gcc $OPTMIZE $DEBUG $LINUX all

cd $MYDIR

# Build distribution tree
#rm -rf ./packaging/$DIRNAME
#mkdir ./packaging/$DIRNAME
#mkdir ./packaging/$DIRNAME/docs
#mkdir ./packaging/$DIRNAME/keyrings
#mkdir ./packaging/$DIRNAME/man
#mkdir ./packaging/$DIRNAME/man/man1

#cp $DOCSDIR/builds/cmdline/PGPCmdLineGuide.pdf ./packaging/$DIRNAME/docs
#cp $DOCSDIR/builds/common/IntrotoCrypto.pdf ./packaging/$DIRNAME/docs
#cp ./CREDITS ./packaging/$DIRNAME/docs
#cp ./packaging/pgp-6.0/docs/WhatsNew.html ./packaging/$DIRNAME/docs
#cp ./packaging/pgp-6.0/docs/LICENSE ./packaging/$DIRNAME/docs

#if [[ $2 = FREE ]] ; then
	cp $DOCSDIR/builds/freeware/Freeware.txt ./packaging/$DIRNAME/docs
#fi

#cp ./packaging/pgp-6.0/keyrings/SampleKeys.asc ./packaging/$DIRNAME/keyrings
#cp ./packaging/pgp-6.0/man/man1/pgp.1 ./packaging/$DIRNAME/man/man1
#cp ./pgp ./packaging/$DIRNAME
#cp ./packaging/pgp-6.0/docs/WHATSNEW ./packaging/$DIRNAME

# Package product
#cd ./packaging
#tar -cf $PACKAGENAME $DIRNAME
